#include "Adafruit_Sensor.h"
#include "Adafruit_AM2320.h"

#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>

Adafruit_AM2320 am2320 = Adafruit_AM2320();
BlynkTimer timer;

#define MoistSensor A0
#define BLYNK_PRINT Serial

int sensorValue = 0;
bool sendMessage = 0;
int TriggerVal = 400;

char auth[] = "auth token";
char ssid[] = "ssid";
char pass[] = "pass";

void sensorDataSend(){
  
  sensorValue = analogRead(MoistSensor);
  
  Blynk.virtualWrite(V5, am2320.readTemperature());
  Blynk.virtualWrite(V6, am2320.readHumidity());
  Blynk.virtualWrite(V7, sensorValue);
  
  if(sensorValue < TriggerVal && sendMessage == 0){
    Blynk.notify("IOT Plant Alert - Plant is low on Water!");
    sendMessage = 1;
  }
  if(sensorValue > TriggerVal + 100 && sendMessage == 1){
    sendMessage = 0;
  }
  
}

void setup() {
  Serial.begin(115200);
  while (!Serial) {
    delay(10);
  }
  am2320.begin();
  Blynk.begin(auth, ssid, pass);
  timer.setInterval(2000L, sensorDataSend);
}

void loop() {
  Blynk.run();
  timer.run();
}
